#include "can_device.h"
#include "uart_device.h"
#include "keyboard.h"
#include "pid.h"
#include "sys.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "arm.h"

short block_num;
int target_claw;
int target_arm;
int target_trans=0;
short block_bool;
short arm_position_bool;
short sensor_bool;
uint8_t sensor_status;
int i,j=0;
int arm_bias;
int trans_bias;
float amp=-6;
int servo_time=0;
int keyboardC_last=0;
int keyboardF_last=0;
int keyboardG_last=0;
int last_mouse=0;
int claw_state=0;
int switch_last=2;

int arm_power_calculate(void){
  //Q->Arm up 
  //E->Arm down
  int16_t arm_power;
  if(rc.kb.bit.E){
    arm_power=1500; 
    target_arm=moto_arm.total_angle;
}
  else{
		if(rc.kb.bit.Q){
    arm_power=-1500;
		}
		else{
		arm_power=0;
		}
	
}
	if(rc.ch2>0){
		
		if(rc.ch2>200)arm_power=4000; //TODO:???
		else{arm_power=rc.ch2*-amp;}
	}   
	
	if(rc.ch2<0){
	
		if(rc.ch2<-200) arm_power=-4000;
		else{arm_power=rc.ch2*-amp;}
	}
	
	
  return arm_power;
}


int arm_close_loop(void){
	int16_t arm_power;
	if(rc.ch2>0) {arm_power=rc.ch2*2; target_arm=moto_arm.total_angle;}
	else{
		if(rc.ch2<0) {arm_power=rc.ch2*2; target_arm=moto_arm.total_angle;}
		else{
			pid_calc(&pid_arm_moto,moto_arm.total_angle,target_arm);
		}
	}
	return arm_power;

}

int claw_power_calculate(void){
  //right click->close
  //left click->open
  int16_t claw_power;
  
	/*if(last_mouse==0&&rc.mouse.l==1)
		claw_state=!claw_state;
	
	last_mouse=rc.mouse.l;
	  
	if(claw_state==1)
		claw_power=3000;
	else claw_power=-3000;*/
	
	if(rc.sw1==1) claw_power=2500;
	if(rc.sw1==2) claw_power=-2500;
	
  return claw_power;
}



void camera_servo_ctrl(){
	int16_t servo_pwm;
	if(keyboardC_last==0&&rc.kb.bit.C==1) servo_time++;
	if(servo_time%2==1) servo_pwm=9000;
	else{servo_pwm=6000;}
	set_pwm_param(PWM_IO1,servo_pwm);
	keyboardC_last=rc.kb.bit.C; //update last value
}


void camera_servo_init(void){
	set_pwm_group_param(PWM_GROUP3,20000);
  start_pwm_output(PWM_IO9);
	set_pwm_param(PWM_IO1,6000);//CAMERA POSITION LOCK UP
}


void trans_param_init(void)
{
	pid_init(&pid_trans_moto, 3000 , 7000, 3.0f, 0.05f, 50.0f);
}

void arm_param_init(void)
{
  pid_init(&pid_arm_moto, 2000, 500, 0.85f, 0.0003f, 20.0f);
}
  

void claw_param_init(void)
{
  pid_init(&pid_arm_moto, 2000, 500, 0.85f, 0.0003f, 20.0f);
}

int trans_power_calculate(void){
	int trans_power;
	if(keyboardF_last==0&&rc.kb.bit.F==1){
		target_trans-=3;
	}
	if(keyboardG_last==0&&rc.kb.bit.G==1){
		target_trans+=3;
	}
	/*switch(rc.sw2){
		case 1: target_trans=17200; break;
		
		case 3: target_trans=8600; break;
		
		case 2: target_trans=0; break;
		
		default: break;
	}
	*/
	
	if(rc.sw2==1&&switch_last==3){//mid->up
		target_trans-=10950;
	}
	if(rc.sw2==2&&switch_last==3){//mid->down
	  target_trans+=10950;
	}
	
	switch_last=rc.sw2;
	keyboardF_last=rc.kb.bit.F;//update last state
	keyboardG_last=rc.kb.bit.G;
	
	
	trans_power=pid_calc(&pid_trans_moto,moto_trans.total_angle,target_trans);
	return trans_power;
 }

 
 
 
 
short arm_position_test(void){//0->down_up_down 1->else
	short result=0;
	return result;
}



void sensor_init(void){
	set_digital_io_dir(DIGI_IO2,IO_INPUT);
}

short sensor_test(void){//0->falseTOtrue 1->TrueToFalse
	short result;
	read_digital_io(LED_IO2,&sensor_status);
	return result;
}



