#include "auto_task.h"
#include "can_device.h"
#include "uart_device.h"
#include "cmsis_os.h"
#include "calibrate.h"
#include "pid.h"
#include "sys.h"
#include  <stdlib.h>

#define Claw 0
#define ArmLeft 1
#define ArmRight 2
#define Trans 3


state_machine super={0};
state_machine sub1={0};
state_machine sub2={0};

int _delay=0;

int16_t mCurrent[4];

static int arm_down_state(){
	sub1.is_finished=1;
		switch(sub1.current){	
			case 0:
				mCurrent[ArmLeft]=-1000;
				mCurrent[ArmRight]=1000;
				mCurrent[Claw]=3000;
				mCurrent[Trans]=0;
                break;
            case 1:
                delay(1000);
                break;
            case 2:
                break;
            case 3:
              	mCurrent[ArmLeft]=1000;
				mCurrent[ArmRight]=-1000;
				mCurrent[Claw]=-3000;
                break;
            //case 4:  ......
		default:
			break;
		}
		if(sub1.is_finished==1)
		{
				sub1.last=sub1.current;
				sub1.current++;
		
		}
		return sub1.current>4?1:0;
} 


static int arm_up_state(){
	sub2.is_finished=1;
		switch(sub2.current){	
			case 0:
				mCurrent[ArmLeft]=1000;
				mCurrent[ArmRight]=-1000;
				mCurrent[Claw]=3000;
				mCurrent[Trans]=0;
                break;
            case 1:
                delay(1000);
                break;
            case 2:
                break;
            case 3:
              	mCurrent[ArmLeft]=1000;
				mCurrent[ArmRight]=-1000;
				mCurrent[Claw]=-3000;
                break;
            //case 4:  ......
		default:
			break;
		}
			if(sub2.is_finished==1)
		{
				sub2.last=sub2.current;
				sub2.current++;
		
		}
		return sub2.current>4?1:0;
} 


void auto_task(const void* argu)
{

   while(1){
		 
		 
		switch(super.current){	
			case 0:
				delay(5000);    //可实现延时
                break;
            case 1:
                mCurrent[ArmLeft]=-1000;
				mCurrent[ArmRight]=1000;
				mCurrent[Claw]=3000;
				mCurrent[Trans]=0;
                break;
            case 2:
                delay(1000);
            case 3:
              mCurrent[ArmLeft]=1000;
				mCurrent[ArmRight]=-1000;
				mCurrent[Claw]=-3000;
                break;
            //case 4:  ......
		default:
			break;
		
		case 99999: //保证延时态让可出线程控制权
			if(_delay>0){ 
			    _delay--;
			    osDelay(1);
			}
			else 
				super.current=super.last;
			break;
		}
		
		if(super.current<99997&&super.is_finished==1)
			jump_next();
		
		send_other_moto_current(mCurrent);
		osDelay(5);
  }
}





static void jump(int i){
	super.last=super.current;
	super.current=i;
}

static void delay(int i){
	_delay=i/6.4;
	jump(99999);
}

	static void jump_back(){
	super.current=super.last;
	super.last=super.current;
}

static void jump_next(){
	jump(super.current+1);
}

static void condition(int i){
	super.is_finished=i;	
}
